/******************************************************************************

  (c) 2009-2011 Scientific Computation Research Center,
      Rensselaer Polytechnic Institute. All rights reserved.

  The LICENSE-SCOREC file included with this distribution describes the terms
  of the SCOREC Non-Commercial License this program is distributed under.

*******************************************************************************/

#include <iostream>
#include <tile.h>

#define TILES_PER_SIDE 8
#define SIZE (TILES_PER_SIDE*TILES_PER_SIDE*4*4)

class simple_ui
{
  public:
    simple_ui():value(0) {}
    size_t value;
};

int main()
{
  TilePattern pattern;
  HardCodedTilePattern1(pattern);
  pattern.SetTilesPerSide(TILES_PER_SIDE);
  typedef std::set<int> neighbors_t;
  typedef std::map<int,neighbors_t> data_t;
  data_t all_neighbors;
  std::map<size_t,simple_ui> distribution;
  for (int rank = 0; rank < SIZE; ++rank)
  {
    pattern.GetNeighborhood(rank,all_neighbors[rank]);
    ++((distribution[all_neighbors[rank].size()]).value);
  }
  for (int rank = 0; rank < SIZE; ++rank)
  {
    neighbors_t& neighbors = all_neighbors[rank];
    neighbors_t::iterator it = neighbors.begin();
    neighbors_t::iterator end = neighbors.end();
    for (; it != end; ++it)
    {
      if (all_neighbors[*it].find(rank) == all_neighbors[*it].end())
      {
        std::cout << "WRONG: " << rank << " is connected to " << *it;
        std::cout << " but " << *it << " is not connected to " << rank << '\n';
      }
    }
  }
  std::map<size_t,simple_ui>::iterator it = distribution.begin();
  for (; it != distribution.end(); ++it)
  {
    std::cout << it->second.value << " processors have " << it->first << " neighbors\n";
  }
}

